'''
===============================================================
===============================================================
buildFromCfg
===============================================================
===============================================================
'''

from panda3d.core import PGTop, PandaNode

   
def getAllChildren(self, pn, nodes_list):
   if type(pn)==type(PandaNode) and type(nodes_list)==type([]):
      num_children=pn.getNumChildren()
      if not num_children: return
      for indx in num_children:
         nodes_list.append(pn.getChild(indx))
      for indx in num_children:
         self.getAllChildren(pn=pn.getChild(indx), nodes_list=nodes_list)
#***********************************************************
def buildFromEgg(self, egg_path, LayoutList):
   obj_bank={}
   #_________loading gui template_______________________________________
   pn=loader.loadModel(egg_path).node() # raise IOError if path is wrong
   num_children=pn.getNumChildren()
   #if not num_children:
   #   print 'wrong model hierarchy'
   #   return
   numerator=0
   #_______name unnamed nodes for search preposes______________________
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      if pn_child.hasName(): continue
      else:
         pn_child.setName(str(pn_child.getClassType())+str(numerator))
         numerator+=1
   #_______explode hierarchy___________________________________________
   treeExplode(obj_bank, pn)
   #_______create controls_____________________________________________
   ...
   #_______resurect tree_______________________________________________
   ...
   #_______return layouts______________________________________________
   num_children=pn.getNumChildren()
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      if  'layout' in str(pn_child.getName()):
         layout_name=str(pn_child.getName())
         LayoutList.update({layout_name:pn_child})
         pn.removeChild(pn_child)
   xxxxxx
         
      
#***********************************************************
def treeExplode(self, obj_bank, pn):
   obj_name=str(pn.getName())
   obj_prnt=str(pn.getParent(0).getName()) if pn.getNumParents() else None
   obj_bank[obj_name]={'obj':pn, 'prnt':obj_prnt}
   num_children=pn.getNumChildren()
   if not num_children: return
   
   for indx in range(num_children):
      pn_child=pn.getChild(indx)
      treeExplode(obj_bank, pn_child)
      
   pn.removeAllChildren()

#***********************************************************
def buildFromDat(self, egg_path, LayoutList):
   pass

def buildFromCfg(self, egg_path, LayoutList):
   pass

def buildFromEgg(self, egg_path):

def __selectLayouts(self, np_base=None):
   print np_base.getName()
   layouts=[]
   if 'layout' in np_base.getName():
      layouts.append(np_base)
   np_children=np_base.getChildren().getPaths()
   if len(np_children)==0:
      return layouts
   for itm in range(np_children):
      layouts=layouts+self._selectLayouts(np_base=itm)
      print layouts,'+',self._selectLayouts(np_base=itm)
   return layouts
