import string
from panda3d.core import PandaNode, NodePath, PGButton, MouseButton
from panda3d.core import BoundingVolume, Texture, PNMImage 
from direct.showbase.DirectObject import DirectObject
from direct.showbase.ShowBase import ShowBase

def buttonInfo(*args):
   if args[0].isButtonDown(): pass
   #print args
   print args[0].getName()
   print args[0].getTransform()

effectList={'getInfo':buttonInfo}


class myButton(DirectObject, PGButton):
    def __init__(self, np=None, effects={}):
        DirectObject.__init__(self)
        PGButton.__init__(self,'')
        if np is None:
            self.setName('Default')
        else:
            if hasattr(np,'getName'): self.setName(np.getName())
        self.effects={}
        self.effects.update(effectList)

        self.setup(np.getChild(0),np.getChild(1)) 
        self.setBoundsType(BoundingVolume.BTBox)
        
        self.b1_click=self.getClickEvent(MouseButton.one())
        self.accept (self.b1_click, self.effects['getInfo'],[self])
       
    def _B2_resend(self):
        #p_event=parent.getPressEvent (Button[1])
        #event...(p_event)
        pass
      
app=ShowBase()
np1=loader.loadModel('..//control_template.egg')
np1.setScale(0.2)

np2=np1.copyTo(np1)
np2.detachNode()

#tex_tmp=np2.getTexture() # don't  work
tex_tmp=np2.findTexture('**')
print 'Original texture name: ', tex_tmp.getFilename()
tex_path=str(tex_tmp.getFilename()).split('/')#[]
print 'Obtained texture name: ', string.join(tex_path,'/')
tex_name=tex_path[-1].split('_')#[]
tex_name=tex_name[0]+'_'+'template2'+tex_name[1][-4:]#string
tex_path=tex_path[:-1]+[tex_name]
tex_path=string.join(tex_path,'/')
print 'Constructed texture name: ', tex_path
print

tex_stage=np2.findTextureStage ('**')
print tex_tmp, 'refcount: ', tex_tmp.getRefCount()
print tex_stage
tex_tmp=tex_tmp.makeCopy()
print tex_tmp
np2.setTexture(tex_tmp,1)
try:
   tex_tmp.read(tex_path)#('..//control_template2.PNG')#!! PNMImage() - not requied
except AssertionError: pass
#print tex_tmp

np=NodePath('TheButtoN')
np1.reparentTo(np)
np2.reparentTo(np)
#np.reparentTo(aspect2d)
#np2.setPos(0,0,0.5)


butt=myButton(np,effectList)
butt=aspect2d.attachNewNode(butt)
app.run()
